<script lang="ts">
	import { run } from 'svelte/legacy';

	import { changeColour } from '../actions/changeColour.js'
	interface Props {
		svgIcon: string;
		accentColour: Record<string, string> | string;
		size?: number;
		style?: string | null;
		root?: HTMLObjectElement | null;
		href?: string;
	}

	let {
		svgIcon,
		accentColour,
		size = 64,
		style = null,
		root = $bindable(null),
		href = ''
	}: Props = $props();

	let rootNode: HTMLObjectElement = $state()

	run(() => {
		changeColour(rootNode, accentColour)
	});

	function onLoad(node: HTMLObjectElement, accentColour: Record<string, string> | string) {
		function listenToContent() {
			node.removeEventListener('load', listenToContent)
			changeColour(node, accentColour)
		}
		node.addEventListener('load', listenToContent)
		rootNode = node
	}
</script>

<a {href}>
	<object
		bind:this={root}
		id="icon"
		type="image/svg+xml"
		data={svgIcon}
		title="icon"
		use:onLoad={accentColour}
		style="width:{size}px; height:{size}px; {style};"
	></object>
</a>

<style>
	object{
		/* Disable inbuilt click events on the SVG */
		pointer-events: none;
	}

</style>